.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include HexDemo.inc

.code

start:

	invoke GetModuleHandle,NULL
	mov		hInstance,eax

    invoke InitCommonControls
	invoke DialogBoxParam,hInstance,IDD_DIALOG1,NULL,addr DlgProc,NULL
	invoke ExitProcess,0

;########################################################################

DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		push	hWin
		pop		hWnd
		
		invoke	GetDlgItem, hWnd, IDC_BTN1
		mov		hButton, eax
		invoke	GetDlgItem, hWnd, IDC_EDT1
		mov		hEdit, eax

	.elseif eax==WM_COMMAND
		mov		eax,wParam
		and		eax,0FFFFh
		.if eax==IDC_BTN1
			mov		esi, offset HexBlock
			mov		ecx, 5
			mov		edi, offset Destination 
			call	Hex_To_Char
			
			invoke	SetWindowText, hEdit, addr Destination
			 
		.endif

	.elseif eax==WM_CLOSE
		invoke EndDialog,hWin,0
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

DlgProc endp

Hex_To_Char	proc
; assume esi = pointer to string
; assume ecx = length of string
; assume edi = output buffer
	
	cld               ; clear direction flag
@loop:
	lodsb             ; load a byte from esi, increment it
	mov ah, al        ; save the byte
	shl al, 4         ; take the top 4 bits
	call Convert_Hex2 ; turn it into an ascii char
	
	;stosb             ; store byte at edi, increment it
	mov ah, al        
	;and al, 0fh       ; take the low 4 bits of loaded byte
	call Convert_Hex2 ; turn it into an ascii char
	stosb             ; store it at edi, increment it
	loop @loop        ; repeat this process #ecx times
	ret               ; bye	
Hex_To_Char endp

Convert_Hex	proc
 	add al, 30h 						; 30h <= al <= 3Fh
	cmp al, 39h 						; is number above '9'?
	jbe @ret    						; nope, we're done
	sub al, 9  
	
@ret: 
	ret

Convert_Hex endp

Convert_Hex2 proc
	
	cmp		al, 09 		; Is the byte less than nine?
	jle		@none
	mov		ah, al		; save the original in the higher part of the register
	sub		al, 09		; take nine off it
	add		ah, al
	mov		al, ah		; put the result into al.  

@none:					; the number is less than 9, take no action. 	
	ret

Convert_Hex2 endp

end start
